<?php
/**
*
* @author Shredder, v.1.0.1
* @copyright (c) 2015 www.phpbb-work.ru
* @license GNU General Public License, version 2 (GPL-2.0)
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('acp/bots');

page_header($user->lang['INFORMATION']);
$user->lang['INFORMATION'] = '<span class="content">Скрипт массового добавления ботов, <b>v.1.0.1</b>. Автор: Shredder,</span> <a href="http://www.phpbb-work.ru/bots-install-script-t124.html" onclick="window.open(this.href); return false;" style="text-decoration: underline;">http://www.phpbb-work.ru/</a>';

// Permission check
$this_url = append_sid(generate_board_url() . "/install_bots.$phpEx");

if ($user->data['user_type'] != USER_FOUNDER)
{
	if (!$user->data['is_registered'])
	{
		login_box($this_url, 'Вы должны быть зарегистрированы и авторизованы для доступа к этой странице.');
	}
	trigger_error('Вы должны быть Основателем для доступа к этой странице.');
}

$ignore_taken = $request->variable('ignore', 0);

$bots = array(
	'AdsBot [Google]'					=> array('AdsBot-Google', ''),
	'Alexa [Bot]'						=> array('ia_archiver', ''),
	'Alta Vista [Bot]'					=> array('Scooter/', ''),
	'Thunderstone [Bot]'				=> array('T-H-U-N-D-E-R-S-T-O-N-E', ''),
	'Baidu [Spider]'					=> array('Baiduspider', ''),
	'Exabot [Bot]'						=> array('Exabot/', ''),
	'FAST Enterprise [Crawler]'			=> array('FAST Enterprise Crawler', ''),
	'FAST WebCrawler [Crawler]'			=> array('FAST-WebCrawler/', ''),
	'Francis [Bot]'						=> array('http://www.neomo.de/', ''),
	'Gigabot [Bot]'						=> array('Gigabot/', ''),
	'Google Adsense [Bot]'				=> array('Mediapartners-Google', ''),
	'Google Desktop'					=> array('Google Desktop', ''),
	'Google Feedfetcher'				=> array('Feedfetcher-Google', ''),
	'Google [Bot]'						=> array('Googlebot', ''),
	'Heise IT-Markt [Crawler]'			=> array('heise-IT-Markt-Crawler', ''),
	'Heritrix [Crawler]'				=> array('heritrix/1.', ''),
	'IBM Research [Bot]'				=> array('ibm.com/cs/crawler', ''),
	'ICCrawler - ICjobs'				=> array('ICCrawler - ICjobs', ''),
	'ichiro [Crawler]'					=> array('ichiro/', ''),
	'Majestic-12 [Bot]'					=> array('MJ12bot/', ''),
	'Metager [Bot]'						=> array('MetagerBot/', ''),
	'MSN NewsBlogs'						=> array('msnbot-NewsBlogs/', ''),
	'MSN [Bot]'							=> array('msnbot/', ''),
	'MSNbot Media'						=> array('msnbot-media/', ''),
	'NG-Search [Bot]'					=> array('NG-Search/', ''),
	'Nutch [Bot]'						=> array('http://lucene.apache.org/nutch/', ''),
	'Nutch/CVS [Bot]'					=> array('NutchCVS/', ''),
	'OmniExplorer [Bot]'				=> array('OmniExplorer_Bot/', ''),
	'Online link [Validator]'			=> array('online link validator', ''),
	'psbot [Picsearch]'					=> array('psbot/0', ''),
	'Seekport [Bot]'					=> array('Seekbot/', ''),
	'Sensis [Crawler]'					=> array('Sensis Web Crawler', ''),
	'SEO Crawler'						=> array('SEO search Crawler/', ''),
	'Seoma [Crawler]'					=> array('Seoma [SEO Crawler]', ''),
	'SEOSearch [Crawler]'				=> array('SEOsearch/', ''),
	'Snappy [Bot]'						=> array('Snappy/1.1 ( http://www.urltrends.com/ )', ''),
	'Steeler [Crawler]'					=> array('http://www.tkl.iis.u-tokyo.ac.jp/~crawler/', ''),
	'Synoo [Bot]'						=> array('SynooBot/', ''),
	'Telekom [Bot]'						=> array('crawleradmin.t-info@telekom.de', ''),
	'TurnitinBot [Bot]'					=> array('TurnitinBot/', ''),
	'Voyager [Bot]'						=> array('voyager/', ''),
	'W3 [Sitesearch]'					=> array('W3 SiteSearch Crawler', ''),
	'W3C [Linkcheck]'					=> array('W3C-checklink/', ''),
	'W3C [Validator]'					=> array('W3C_Validator', ''),
	'WiseNut [Bot]'						=> array('http://www.WISEnutbot.com', ''),
	'YaCy [Bot]'						=> array('yacybot', ''),
	'Yahoo MMCrawler [Bot]'				=> array('Yahoo-MMCrawler/', ''),
	'Yahoo Slurp [Bot]'					=> array('Yahoo! DE Slurp', ''),
	'Yahoo [Bot]'						=> array('Yahoo! Slurp', ''),
	'YahooSeeker [Bot]'					=> array('YahooSeeker/', ''),
	'Yandex [Images]'					=> array('YandexImages/', ''),
	'Yandex [Video]'					=> array('YandexVideo/', ''),
	'Yandex [Media]'					=> array('YandexMedia/', ''),
	'Yandex [Blogs]'					=> array('YandexBlogs/', ''),
	'Yandex [Addurl]'					=> array('YandexAddurl/', ''),
	'Yandex [Direct]'					=> array('YandexDirect/', ''),
	'Yandex [Metrika]'					=> array('YandexMetrika/', ''),
	'Yandex [Catalog]'					=> array('YandexCatalog/', ''),
	'Yandex [News]'						=> array('YandexNews/', ''),
	'ABCdatos [Bot]'					=> array('ABCdatos', ''),
	'Rambler [Bot]'						=> array('Rambler', ''),
	'Twiceler [Bot]'					=> array('twiceler', ''),
	'Mail.Ru [Bot]'						=> array('Mail.Ru', ''),
	'WebAlta [Bot]'						=> array('WebAlta Crawler', ''),
	'Aport [Bot]'						=> array('Aport', ''),
	'Bing [Bot]'						=> array('bingbot/', ''),
	'AEIWI [Bot]'						=> array('Aeiwi', ''),
	'ISC Open Index [Bot]'				=> array('ISC Open Index crawler', ''),
	'INFOmine [Bot]'					=> array('iVia', ''),
	'ABACHO [Bot]'						=> array('AbachoBOT', ''),
	'AISearch [Bot]'					=> array('AISearchBot', ''),
	'Aberja [Bot]'						=> array('Aberja Checkomat', ''),
	'Abonti [Bot]'						=> array('Abonti', ''),
	'About [Bot]'						=> array('About/', ''),
	'Accoona [Bot]'						=> array('accoona', ''),
	'ActiveBookmark [Bot]'				=> array('ActiveBookmark', ''),
	'Aesop [Bot]'						=> array('AESOP', ''),
	'Agada [Bot]'						=> array('agadine', ''),
	'AideRSS [RSS]'						=> array('AideRSS', ''),
	'Allesklar [Bot]'					=> array('Allesklar', ''),
	'Amfibi [Bot]'						=> array('Amfibibot', ''),
	'Amidalla [Bot]'					=> array('amibot', ''),
	'Apple-PubSub [Bot]'				=> array('Apple-PubSub', ''),
	'Arachnid Crawler [Bot]'			=> array('ArachBot', ''),
	'Arexera [Bot]'						=> array('X-Crawler', ''),
	'Arianna [Bot]'						=> array('arianna', ''),
	'AustLII [Bot]'						=> array('Gromit', ''),
	'Axada [Bot]'						=> array('axadine', ''),
	'BDProtect [Bot]'					=> array('BPImageWalker', ''),
	'Babaloo [Bot]'						=> array('BabalooSpider', ''),
	'Balihoo [Bot]'						=> array('Balihoo', ''),
	'Become [Bot]'						=> array('BecomeBot', ''),
	'Best of the Web [Bot]'				=> array('BOTW Spider', ''),
	'Big Brother [Bot]'					=> array('Big Brother', ''),
	'BigClique [Bot]'					=> array('BigCliqueBOT', ''),
	'Bim Zone [Bot]'					=> array('bim-zone', ''),
	'BitTorrent [Bot]'					=> array('BTbot', ''),
	'BlogDex [Bot]'						=> array('BlogBot', ''),
	'Bloglines [Bot]'					=> array('Bloglines', ''),
	'Blue.lu [Bot]'						=> array('Confuzzledbot', ''),
	'BoardReader [Bot]'					=> array('BoardReader', ''),
	'Boitho [Bot]'						=> array('boitho.com', ''),
	'Boston Project [Spam]'				=> array('Boston Project', ''),
	'Brandwatch [Bot]'					=> array('Jakarta Commons', ''),
	'Business.com [Bot]'				=> array('bdcindexer', ''),
	'BuzzRanking [Bot]'					=> array('BuzzRankingBot', ''),
	'CSS Validator [W3C]'				=> array('W3C_CSS_Validator', ''),
	'CanadianContent [Bot]'				=> array('RoboCrawl', ''),
	'Cazoodle [Bot]'					=> array('CazoodleBot', ''),
	'Check Favorites [Bot]'				=> array('Check Favorites', ''),
	'CheckWeb [Bot]'					=> array('CheckWeb', ''),
	'Checkbot [Bot]'					=> array('Checkbot', ''),
	'Checklinks [Bot]'					=> array('CheckLinks', ''),
	'Cipinet [Bot]'						=> array('CipinetBot', ''),
	'Claymont [Bot]'					=> array('Claymont.com', ''),
	'Clush [Bot]'						=> array('Clushbot', ''),
	'CommonCrawl [Bot]'					=> array('CCBot', ''),
	'Convera [Bot]'						=> array('Convera', ''),
	'Cosmoty [Bot]'						=> array('beautybot', ''),
	'CreativeCommons [Bot]'				=> array('CreativeCommons', ''),
	'Custo [Bot]'						=> array('Custo', ''),
	'Cyber Spyder Link Test [Bot]'		=> array('CyberSpyder', ''),
	'CyberPatrol [Bot]'					=> array('CyberPatrol', ''),
	'Cydral [Bot]'						=> array('CydralSpider', ''),
	'Cynthia [Bot]'						=> array('Cynthia', ''),
	'DZNET [Bot]'						=> array('Kevin', ''),
	'DailyOrbit [Bot]'					=> array('Orbiter', ''),
	'Daum [Bot]'						=> array('Daumoa', ''),
	'Dead Link Check [Bot]'				=> array('DeadLinkCheck', ''),
	'DeepIndex [Bot]'					=> array('DeepIndex', ''),
	'DepSpid [Bot]'						=> array('DepSpid', ''),
	'Desert Realm [Bot]'				=> array('DesertRealm', ''),
	'Die Blinde Kuh [Bot]'				=> array('Die Blinde Kuh', ''),
	'Diffbot [Bot]'						=> array('Diffbot', ''),
	'DiscoveryEngine [Bot]'				=> array('discobot', ''),
	'Ditto [Bot]'						=> array('DittoSpyder', ''),
	'DomainTools [Bot]'					=> array('SurveyBot', ''),
	'DotNet [Bot]'						=> array('DotBot', ''),
	'DumbFind [Bot]'					=> array('Dumbot', ''),
	'EXPelite [Spam]'					=> array('ExtractorPro', ''),
	'EmailSearch [Spam]'				=> array('EmailSearch', ''),
	'Enaball [Bot]'						=> array('EnaBot', ''),
	'Entireweb [Bot]'					=> array('Speedy Spider', ''),
	'Envolk [Bot]'						=> array('envolk', ''),
	'Exactseek [Bot]'					=> array('ExactSeek', ''),
	'Exalead Thumbnails [Bot]'			=> array('Exabot-Thumbnails', ''),
	'Exooba [Bot]'						=> array('exooba', ''),
	'FULLSearch [Bot]'					=> array('FULLSearch', ''),
	'Facebook Scraper [Bot]'			=> array('facebookscraper', ''),
	'Facebook [Bot]'					=> array('facebookexternalhit', ''),
	'FakeWordpress [Spam]'				=> array('WordPress/', ''),
	'OWS'								=> array('owsBot', ''),
	'Gais'								=> array('Gaisbot/', ''),
	'Twenga'							=> array('TwengaBot', ''),
	'Favorstar [Bot]'					=> array('favorstarbot', ''),
	'Feed Validator [W3C]'				=> array('FeedValidator', ''),
	'MirarSearch'						=> array('Mirar Search Indexing Agent', ''),
	'Twitmatic'							=> array('twitmatic', ''),
	'PycURL'							=> array('PycURL/', ''),
	'PostRank2'							=> array('PostRank/', ''),
	'JS-Kit'							=> array('JS-Kit URL Resolver', ''),
	'Twitter'							=> array('Twitterbot/', ''),
	'LongURL'							=> array('LongURL API', ''),
	'Google AppEngine'					=> array('AppEngine-Google', ''),
	'Bit.ly'							=> array('bitlybot', ''),
	'Filangy [Bot]'						=> array('Filangy', ''),
	'Fireball [Bot]'					=> array('Fireball', ''),
	'Focuseek [Bot]'					=> array('focuseekbot', ''),
	'Furl [Bot]'						=> array('FurlBot', ''),
	'FyberSearch [Bot]'					=> array('FyberSpider', ''),
	'Galaxy [Bot]'						=> array('GalaxyBot', ''),
	'Geona [Bot]'						=> array('GeonaBot', ''),
	'Girafa [Bot]'						=> array('Girafabo', ''),
	'GoForIt [Bot]'						=> array('GOFORITBOT', ''),
	'GoGuides [Bot]'					=> array('Goblin', ''),
	'Nextthing [Bot]'					=> array('nextthing.org', ''),
	'Megaglobe [Crawler]'				=> array('Megaglobe Crawler', ''),
	'MyFamily [Bot]'					=> array('MyFamilyBot', ''),
	'Mirago [Bot]'						=> array('Mirago-Test-Robot', ''),
	'Google Search Appliance [Bot]'		=> array('gsa-crawler', ''),
	'Trovatore [Bot]'					=> array('IlTrovatore', ''),
	'Exooba [Crawler]'					=> array('exoob', ''),
	'Google Wireless Transcoder [Bot]'	=> array('Google Wireless Transcoder', ''),
	'HMSEbot [Spam]'					=> array('HMSEbot', ''),
	'HTML2JPG [Bot]'					=> array('HTML2JPG', ''),
	'HTTrack [Bot]'						=> array('HTTrack', ''),
	'Hatena Antenna [Bot]'				=> array('Hatena Antenna', ''),
	'Heeii [Bot]'						=> array('Heeii', ''),
	'Heise IT-Markt [Bot]'				=> array('IT-Markt', ''),
	'Homerweb [Bot]'					=> array('Homerbot', ''),
	'Hoppa! [Bot]'						=> array('Toutatis', ''),
	'Html Link Validator [Bot]'			=> array('Html Link Validator', ''),
	'IceRocket [Bot]'					=> array('BlogzIce', ''),
	'IconSurf [Bot]'					=> array('IconSurf', ''),
	'Il Trovatore [Bot]'				=> array('IlTrovatore-Setaccio', ''),
	'Ilse [Bot]'						=> array('IlseBot', ''),
	'ImageShack [Bot]'					=> array('ImageShack Image Fetcher', ''),
	'Indy Library [Spam]'				=> array('Indy Library', ''),
	'Information Credibility Criteria Project [Bot]'	=> array('ICC-Crawler', ''),
	'InternetSeer [Bot]'				=> array('InternetSeer.com', ''),
	'InternetServicesResearch [Bot]'	=> array('MSR-ISRCCrawler', ''),
	'JCheckLinks [Bot]'					=> array('JCheckLinks', ''),
	'Jyxo [Bot]'						=> array('Jyxobot', ''),
	'Kalooga [Bot]'						=> array('Kalooga', ''),
	'Keywen Encyclopedia Links [Bot]'	=> array('KeywenBot', ''),
	'Keywen Encyclopedia [Bot]'			=> array('EasyDL', ''),
	'Kvasir [Bot]'						=> array('Solbot', ''),
	'Larbin [Bot]'						=> array('larbin', ''),
	'LinkAlarm [Bot]'					=> array('LinkAlarm', ''),
	'LinkChecking [Bot]'				=> array('LinkWalker', ''),
	'LinkLint [Bot]'					=> array('LinkLint', ''),
	'LinkNZ [Bot]'						=> array('linknzbot', ''),
	'Lookseek [Bot]'					=> array('Seeker', ''),
	'Looksmart [Bot]'					=> array('MantraAgent', ''),
	'Lycos [Bot]'						=> array('Lycos', ''),
	'MLBot [Bot]'						=> array('MLBot', ''),
	'MOMspider [Bot]'					=> array('MOMspider', ''),
	'MSIEcrawler [Bot]'					=> array('msiecrawler', ''),
	'MSN Mobile [Bot]'					=> array('MSMOBOT', ''),
	'Magpie [Bot]'						=> array('magpie-crawler', ''),
	'Megaglobe [Bot]'					=> array('Megaglobe', ''),
	'Megaproxy [Bot]'					=> array('ProxyOS', ''),
	'Metaspinner [Bot]'					=> array('Metaspinner', ''),
	'Microsoft Research [Bot]'			=> array('MSRBOT', ''),
	'MixCat [Bot]'						=> array('Mixcat Crawler', ''),
	'MoPilot [Bot]'						=> array('w@pSpider', ''),
	'Mojeek [Bot]'						=> array('MojeekBot', ''),
	'Morfeo [Bot]'						=> array('holmes', ''),
	'Munax [Bot]'						=> array('Munax', ''),
	'Mylinea [Bot]'						=> array('Mylinea', ''),
	'NationalDirectory [Bot]'			=> array('NDSpider', ''),
	'Naver [Bot]'						=> array('Yeti', ''),
	'NetMechanic [Bot]'					=> array('NetMechanic', ''),
	'Netcraft WebServerSurvey [Bot]'	=> array('Netcraft Web Server Survey', ''),
	'NextLinks [Bot]'					=> array('findlinks', ''),
	'Nextopia [Bot]'					=> array('Nextopia', ''),
	'Nokodo [Bot]'						=> array('NokodoBot', ''),
	'Noxtrum [Bot]'						=> array('noxtrumbot', ''),
	'NutchCVS [Bot]'					=> array('NutchCVS', ''),
	'ObjectsSearch [Bot]'				=> array('ObjectsSearch', ''),
	'Omgili [Bot]'						=> array('omgilibot', ''),
	'Onet.pl [Bot]'						=> array('Onet.pl', ''),
	'Openfind [Bot]'					=> array('Openbot', ''),
	'Oxide [Bot]'						=> array('Anthill', ''),
	'P3P Validator [W3C]'				=> array('P3P Validator', ''),
	'PEERbot [Bot]'						=> array('PEERbot', ''),
	'PHP Version Tracker [Bot]'			=> array('PHP version tracker', ''),
	'Patsearch [Bot]'					=> array('Patwebbot', ''),
	'webcollage [Bot]'					=> array('webcollage', ''),
	'Picosearch [Bot]'					=> array('PicoSearch', ''),
	'Pingdom [Bot]'						=> array('Pingdom', ''),
	'Pipeline [Bot]'					=> array('pipeLiner', ''),
	'Polybot [Bot]'						=> array('potybol', ''),
	'Popdex [Bot]'						=> array('Popdexter', ''),
	'vBSEO [Bot]'						=> array('vBSEO', ''),
	'Search.ch [Bot]'					=> array('search.ch', ''),
	'mobileOK Checker [W3C]'			=> array('W3C-mobileOK', ''),
	'Powerset [Bot]'					=> array('zermelo', ''),
	'Proximic [Bot]'					=> array('proximic', ''),
	'Qango [Bot]'						=> array('Qango', ''),
	'Quepasa [Bot]'						=> array('QuepasaCreep', ''),
	'REAP Project [Bot]'				=> array('REAP-crawler', ''),
	'RIX [Bot]'							=> array('RixBot', ''),
	'RPonline [Bot]'					=> array('BlitzBOT', ''),
	'RSS-Reader [RSS]'					=> array('RSS-Reader', ''),
	'RSS-SPIDER [RSS]'					=> array('RSS-SPIDER', ''),
	'ReciprocalLinksChecker [Bot]'		=> array('reciprocal links checker', ''),
	'Robots.txt Validator [Bot]'		=> array('Robots.txt Validator', ''),
	'SEO Crawler [Bot]'					=> array('SEO search', ''),
	'ScoutJet [Bot]'					=> array('ScoutJet', ''),
	'ScrubTheWeb [Bot]'					=> array('Scrubby', ''),
	'SearchByUSA [Bot]'					=> array('SearchByUsa', ''),
	'SearchHippo [Bot]'					=> array('Fluffy the spider', ''),
	'SearchScout [Bot]'					=> array('ClariaBot', ''),
	'SearchUK [Bot]'					=> array('MegaSheep', ''),
	'Searchalot [Bot]'					=> array('SEARCHALOT', ''),
	'Searchme [Bot]'					=> array('Charlotte', ''),
	'SecureComputing [Bot]'				=> array('page_prefetcher', ''),
	'Semantic Data Extractor [W3C]'		=> array('Python-urllib', ''),
	'Setooz [Bot]'						=> array('OOZBOT', ''),
	'Seznam [Bot]'						=> array('SeznamBot', ''),
	'Shelob [Spam]'						=> array('shelob', ''),
	'Shoula! [Bot]'						=> array('Shoula', ''),
	'Simply [Bot]'						=> array('Argus', ''),
	'SingingFish [Bot]'					=> array('asterias', ''),
	'Site Valet [Bot]'					=> array('Valet', ''),
	'SiteSearcher [Bot]'				=> array('SSearch', ''),
	'SiteSell [Bot]'					=> array('SBIder', ''),
	'SiteSpider [Bot]'					=> array('SiteSpider', ''),
	'Sitesearch.ca [Bot]'				=> array('Reaper', ''),
	'SitiDi [Bot]'						=> array('SitiDiBot', ''),
	'Skaffe [Bot]'						=> array('Skampy', ''),
	'Skizzle [Bot]'						=> array('SKIZZLE', ''),
	'Snap Shots Preview [Bot]'			=> array('SnapPreviewBot', ''),
	'Snap Shots [Bot]'					=> array('Snapbot', ''),
	'Snoopy [Bot]'						=> array('Snoopy', ''),
	'SoMusical! [Bot]'					=> array('MusicWalker', ''),
	'Sonic [Spam]'						=> array('EmailSiphon', ''),
	'Soso [Bot]'						=> array('Sosospider', ''),
	'Speedy Spider [Bot]'				=> array('speedy_spider', ''),
	'SpiderMonkey [Bot]'				=> array('SpiderMonkey', ''),
	'Spinn3r [Bot]'						=> array('Spinn3r', ''),
	'Startpagina [Bot]'					=> array('Startpagina', ''),
	'Suchbot [Bot]'						=> array('suchbot', ''),
	'Suchen.de [Bot]'					=> array('suchen.de', ''),
	'Suchknecht [Bot]'					=> array('Suchknecht', ''),
	'Suchmaschine21 [Bot]'				=> array('CoolBot', ''),
	'SurfSafely [Bot]'					=> array('Submission Scontent.csspider', ''),
	'Sygol [Bot]'						=> array('sygol', ''),
	'Syno [Bot]'						=> array('Synoobot', ''),
	'Teradex [Bot]'						=> array('Teradex', ''),
	'Szukacz [Bot]'						=> array('Szukacz', ''),
	'The Web Moose [Bot]'				=> array('WebMoose', ''),
	'TinEye [Bot]'						=> array('TinEye', ''),
	'Tkensaku [Bot]'					=> array('Tkensaku', ''),
	'Trampelpfad [Bot]'					=> array('Trampelpfad', ''),
	'Tricus [Bot]'						=> array('Rotondo', ''),
	'TulipChain [dmoz]'					=> array('TulipChain', ''),
	'TurnPike [Bot]'					=> array('Turnpike', ''),
	'TutorGig [Bot]'					=> array('TutorGig', ''),
	'Twotrees [Bot]'					=> array('Willow Internet Crawler', ''),
	'Tygo [Bot]'						=> array('Tygo', ''),
	'UKWizz [Bot]'						=> array('Mackster', ''),
	'UnCHAOS [Bot]'						=> array('UnChaos', ''),
	'Updated! [Bot]'					=> array('updated', ''),
	'Verity [Bot]'						=> array('vspider', ''),
	'Ask Jeeves [Bot]'					=> array('Ask Jeeves', ''),
	'Nuill [Bot]'						=> array('Twiceler-0.9', ''),
	'mnoGoSearch [Bot]'					=> array('Mnogosearch', ''),
	'mirago.de [Bot]'					=> array('HeinrichderMirago', ''),
	'mirago.co.uk [Bot]'				=> array('HenrytheMirago', ''),
	'libwww script [Spam]'				=> array('libwww-perl', ''),
	'iOpus [Bot]'						=> array('iopus', ''),
	'dmoz [Bot]'						=> array('Robozilla', ''),
	'dir.com [Bot]'						=> array('Pompos', ''),
	'blogWatcher [Bot]'					=> array('blogWatcher', ''),
	'ZoomInfo [Bot]'					=> array('NextGenSearchBot', ''),
	'Zerx [Bot]'						=> array('zerxbot', ''),
	'Zao [Bot]'							=> array('Zao', ''),
	'Visvo [Bot]'						=> array('VisBot', ''),
	'Voila [Bot]'						=> array('VoilaBot', ''),
	'Youdao [Bot]'						=> array('YoudaoBot', ''),
	'Yodao [Bot]'						=> array('YodaoBot', ''),
	'Yellowpet [Bot]'					=> array('yellopet', ''),
	'Yebol [Bot]'						=> array('YebolBot', ''),
	'Yanga [Bot]'						=> array('Yanga', ''),
	'Yahoo Search Marketing [Bot]'		=> array('YahooYSMcm', ''),
	'Yahoo Feed Seeker [RSS]'			=> array('YahooFeedSeeker', ''),
	'Wotbox [Bot]'						=> array('WSB', ''),
	'WiseGuys [Bot]'					=> array('Vagabondo', ''),
	'Wikia Search [Bot]'				=> array('GrubNG', ''),
	'Whitevector [Bot]'					=> array('Whitevector Crawler', ''),
	'WhatUSeek [Bot]'					=> array('whatUseek', ''),
	'Wget [Spam]'						=> array('Wget', ''),
	'Webglimpse [Bot]'					=> array('Webglimpse', ''),
	'WebSquash [Bot]'					=> array('Websquash', ''),
	'WebCrawl [Bot]'					=> array('webcrawl', ''),
	'WebCorp [Bot]'						=> array('WebCorp', ''),
	'WebCopy [Bot]'						=> array('WebCopy', ''),
	'WebAlta [Bot]'						=> array('WebAlta', ''),
	'Walhello [Bot]'					=> array('appie', ''),
	'WISEnutbot [Bot]'					=> array('WISEnutbot', ''),
	'WBpagechecker [Bot]'				=> array('WBpagechecker', ''),
	'W3SiteSearch [Bot]'				=> array('W3SiteSearch', ''),
	'W3M2 [Bot]'						=> array('W3M2', ''),
);

include_once($phpbb_root_path . 'includes/functions_user.' . $phpEx);

$sql = 'SELECT group_id, group_colour
	FROM ' . GROUPS_TABLE . "
	WHERE group_name = 'BOTS'
		AND group_type = " . GROUP_SPECIAL;
$result = $db->sql_query($sql);
$group_row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if (!$group_row)
{
	trigger_error($user->lang['NO_BOT_GROUP']);
}

$error = array();

foreach ($bots as $bot_name => $bot_ary)
{
	$bot_row = array(
		'bot_name'		=> utf8_normalize_nfc($bot_name),
		'bot_agent'		=> $bot_ary[0],
		'bot_ip'		=> $bot_ary[1],
	);

	if (!$bot_row['bot_agent'] && !$bot_row['bot_ip'])
	{
		$error[] = $user->lang['ERR_BOT_NO_MATCHES'] . ' - ' . '<b>' . $bot_row['bot_name'] . '</b>';
	}

	if ($bot_row['bot_ip'] && !preg_match('#^[\d\.,:]+$#', $bot_row['bot_ip']))
	{
		if (!$ip_list = gethostbynamel($bot_row['bot_ip']))
		{
			$error[] = $user->lang['ERR_BOT_NO_IP'] . ' - ' . '<b>' . $bot_row['bot_name'] . '</b>';
		}
		else
		{
			$bot_row['bot_ip'] = implode(',', $ip_list);
		}
	}
	$bot_row['bot_ip'] = str_replace(' ', '', $bot_row['bot_ip']);

	// Make sure the admin is not adding a bot with an user agent similar to his one
	if ($bot_row['bot_agent'] && substr($user->data['session_browser'], 0, 149) === substr($bot_row['bot_agent'], 0, 149))
	{
		$error[] = $user->lang['ERR_BOT_AGENT_MATCHES_UA'] . ' - ' . '<b>' . $bot_row['bot_name'] . '</b>';
	}

	// Admins might want to use names otherwise forbidden, thus we only check for duplicates.
	$sql = 'SELECT username
		FROM ' . USERS_TABLE . "
		WHERE username_clean = '" . $db->sql_escape(utf8_clean_string($bot_row['bot_name'])) . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	if ($row)
	{
		if ($ignore_taken)
		{
			unset($bots[$bot_name]);
		}
		else
		{
			$error[] = $user->lang['BOT_NAME_TAKEN'] . ' - ' . '<b>' . $bot_row['bot_name'] . '</b>';
		}
	}
}

if (sizeof($error))
{
	trigger_error('<span class="error">Не было добавлено ни одного бота. Исправьте следующие ошибки:</span><br /><br />' . implode('<br />', $error));
}

$bot_count = 0;

foreach ($bots as $bot_name => $bot_ary)
{
	$bot_row = array(
		'bot_name'		=> utf8_normalize_nfc($bot_name),
		'bot_agent'		=> $bot_ary[0],
		'bot_ip'		=> $bot_ary[1],
		'bot_active'	=> true,
		'bot_lang'		=> $config['default_lang'],
		'bot_style'		=> $config['default_style'],
	);

	$user_id = user_add(array(
		'user_type'				=> (int) USER_IGNORE,
		'group_id'				=> (int) $group_row['group_id'],
		'username'				=> (string) $bot_row['bot_name'],
		'user_regdate'			=> time(),
		'user_password'			=> '',
		'user_colour'			=> (string) $group_row['group_colour'],
		'user_email'			=> '',
		'user_lang'				=> (string) $bot_row['bot_lang'],
		'user_style'			=> (int) $bot_row['bot_style'],
		'user_allow_massemail'	=> 0,
	));

	$sql = 'INSERT INTO ' . BOTS_TABLE . ' ' . $db->sql_build_array('INSERT', array(
		'user_id'		=> (int) $user_id,
		'bot_name'		=> (string) $bot_row['bot_name'],
		'bot_active'	=> (int) $bot_row['bot_active'],
		'bot_agent'		=> (string) $bot_row['bot_agent'],
		'bot_ip'		=> (string) $bot_row['bot_ip'])
	);
	$db->sql_query($sql);

	add_log('admin', 'LOG_BOT_ADDED', $bot_row['bot_name']);

	++$bot_count;
}

$cache->destroy('_bots');

trigger_error('Боты успешно добавлены. Общее число добавленных ботов: <b>' . $bot_count . '</b>');

?>